#include <string.h>
#include <csignal>
#include <cstdio>
#include <cstdlib>
#include <utility>
#include <string>
#include "Anna.h"
#include "Bruno.h"
namespace{
  FILE *in, *out;
  int N, L;
  std::string send;
  int send_calls = 0;
}
void wrong(int num){
  fprintf(out, "%d\n", num);
  fflush(out);
  exit(0);
}
void Send(std::string S){
  if (send_calls == 1){
    wrong(3);
  }
  if (!(1 <= (int) S.size() && (int) S.size() <= 100000)){
    wrong(1);
  }
  for (int i = 0; i < S.size(); i++){
    if (!(S[i] == '0' || S[i] == '1')){
      wrong(2);
    }
  }
  send = S;
  send_calls++;
}
int main(int argc, char** argv){
  if (argc < 4){
    fprintf(stderr, "Usage: %s <in> <out> <shard>\n", argv[0]);
    return 1;
  }
  signal(SIGPIPE, SIG_IGN);
  out = fopen(argv[2], "w");
  in = fopen(argv[1], "r");
  int shard = atoi(argv[3]);
  char prepare[20];
  if (fscanf(in, "%s", prepare) != 1){
    fprintf(stderr, "program failed to read data from manager\n");
    exit(1);
  }
  fprintf(out, "Start\n");
  fflush(out);
  if (shard == 0){
    char flag[20];
    if (fscanf(in, "%s", flag) != 1){
      fprintf(stderr, "user program 0 failed to read data from manager");
      wrong(-1);
    }
    if (strcmp("WA", flag) == 0){
      exit(0);
    } else if (strcmp("Success", flag) != 0){
      fprintf(stderr, "wrong manager message to user program 0\n");
      wrong(-1);
    }
    if (fscanf(in, "%d", &N) != 1){
      fprintf(stderr, "user program 0 failed to read data from manager");
      wrong(-1);
    }
    Anna(N);
    if (send_calls == 0){
      wrong(4);
    }
    fprintf(out, "%d\n", 0);
    fflush(out);
    fprintf(out, "%d\n", (int) send.size());
    fflush(out);
		for (int i = 0; i < send.size(); i++){
			fprintf(out, "%c", send[i]);
		}
    fprintf(out, "\n");
		fflush(out);
    if (fscanf(in, "%s", flag) != 1){
      fprintf(stderr, "user program 0 failed to read data from manager");
			exit(0);
    }
  }  
  if (shard == 1){
     char flag[20];
    if (fscanf(in, "%s", flag) != 1){
      fprintf(stderr, "user program 1 failed to read data from manager");
      wrong(-1);
    }
    if (strcmp("WA", flag) == 0){
      exit(0);
    } else if (strcmp("Success", flag) != 0){
      fprintf(stderr, "wrong manager message to user program 0\n");
      wrong(-1);
    }
    if (fscanf(in, "%d", &N) != 1){
      fprintf(stderr, "user program 1 failed to read data from manager");
      wrong(-1);
    }
    if (fscanf(in, "%d", &L) != 1){
      fprintf(stderr, "user program 1 failed to read data from manager");
      wrong(-1);
    }
    char buf[100000];
		for (int i = 0; i < 100000; i++){
			buf[i] = 0;
		}
		if (fscanf(in, "%s", buf) != 1){
			fprintf(stderr, "user program 1 failed to read data from manager");
			wrong(-1);
		}
    std::string S;
		for (int i = 0; i < L; i++){
      S += buf[i];
    }
    int N2 = Bruno(S);
    if (!(1 <= N2 && N2 <= 100000)){
      wrong(5);
    }
    if (N2 != N){
      wrong(6);
    }
    fprintf(out, "%d\n", 0);
    fflush(out);
  }
}